centos中使用python遇到的几个问题

用python搞了一个从excel中读取cobbler节点信息并加入cobbler中的脚本,运行的过程中出了不少问题,这里记录下来,方便日后查找!

 

一、yum install python,我通过这个命令安装python,默认安装的是2.6的版本,但是当我把python 2.6安装完成后,发现cobbler的WEB管理页面无法打开了,查看apahce的错误日志:

 

[html][/html] view plaincopy

  1. [Sun Jul 07 20:13:01 2013] [error] [client 192.168.21.94] ImportError: cannot import name urandom
  2. [Sun Jul 07 20:13:02 2013] [error] [client 192.168.21.94] File does not exist: /var/www/html/favicon.ico
  3. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94] mod_wsgi (pid=10816): Target WSGI script ‘/usr/share/cobbler/web/cobbler.w
  4. sgi’ cannot be loaded as Python module.
  5. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94] mod_wsgi (pid=10816): Exception occurred processing WSGI script ‘/usr/shar
  6. e/cobbler/web/cobbler.wsgi’.
  7. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94] Traceback (most recent call last):
  8. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]   File “/usr/share/cobbler/web/cobbler.wsgi”, line 9, in <module>
  9. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]     import django.core.handlers.wsgi
  10. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]   File “/usr/lib/python2.6/site-packages/django/core/handlers/wsgi.py”, li
  11. ne 10, in <module>
  12. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]     from django import http
  13. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]   File “/usr/lib/python2.6/site-packages/django/http/__init__.py”, line 12
  14. 3, in <module>
  15. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]     from django.utils.http import cookie_date
  16. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]   File “/usr/lib/python2.6/site-packages/django/utils/http.py”, line 7, in
  17.  <module>
  18. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]     from email.Utils import formatdate
  19. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]   File “/usr/lib64/python2.6/email/__init__.py”, line 79, in __getattr__
  20. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]     __import__(self.__name__)
  21. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]   File “/usr/lib64/python2.6/email/utils.py”, line 27, in <module>
  22. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]     import random
  23. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]   File “/usr/lib64/python2.6/random.py”, line 47, in <module>
  24. [Sun Jul 07 20:31:09 2013] [error] [client 192.168.21.94]     from os import urandom as _urandom

缺少urandom模块,python2.6版本里默认没有这个模块,随即将python升级到2.7版本。

升级过程:

1、下载Python 2.7源码:

wget http://www.python.org/ftp/python/2.7.2/Python-2.7.2.tgz

下载

2、解压源码包:

tar -zxvf Python-2.7.2.tgz

3、编译:

cd Python-2.7.2

./configure  –prefix=/usr

4、make&&make install

安装完成后测试web界面可以正常打开了,但是使用yum安装软件的时候会发现不能使用,原因是yum与python有依赖关系,yum是急于python写的,运行yum命令时会调用pyton;

vi /usr/bin/yum

将#!/usr/bin/pyton 改成:#!/usr/bin/pyton2.6,改成你系统默认的版本即可,不然他会调用高版本的python软件包,但是是找不到的,需要做相关配置才行,这里为了方便就直接改了就可以使用了。

二、在安装了python2.7后执行cobbler的相关命令也会有问题

[html][/html] view plaincopy

  1. [root@cobbler scripts]# ./addnode2.py cobbler.xls
  2. add test1 aa:bb:cc:dd 19:2.:16:8.:0.:2
  3. add test2 aa:bb:cc:dd 19:2.:16:8.:0.:3
  4. [root@cobbler scripts]# Traceback (most recent call last):
  5.   File “/usr/bin/cobbler”, line 17, in <module>
  6.     import cobbler.cli as app
  7. ImportError: No module named cobbler.cli
  8. Traceback (most recent call last):
  9.   File “/usr/bin/cobbler”, line 17, in <module>
  10.     import cobbler.cli as app
  11. ImportError: No module named cobbler.cli
  12. [root@cobbler scripts]# cobbler get-loaders
  13. Traceback (most recent call last):
  14.   File “/usr/bin/cobbler”, line 17, in <module>
  15.     import cobbler.cli as app
  16. ImportError: No module named cobbler.cli

这也是由于python版本导致的,同样:vi /usr/bin/cobbler

将调用的python版本修改为2.6即可。

三、补充:关于安装EasyInstall 遇到的问题:

下载:

wget http://pypi.python.org/packages/2.7/s/setuptools/setuptools-0.6c11-py2.7.egg

安装:

[html][/html] view plaincopy

  1. sh  setuptools-0.6c11-py2.7.egg

报错:

[html][/html] view plaincopy

  1. Traceback (most recent call last):
  2. File “<string>”, line 1, in <module>
  3. zipimport.ZipImportError: can’t decompress data; zlib not available

解决方法:

1、安装依赖zlib、zlib-devel

2、重新编译安装Python

 

[html][/html] view plaincopy

  1. ./configure
  2. 编辑Modules/Setup文件
  3. 找到下面这句,去掉注释
  4. #zlib zlibmodule.c -I$(prefix)/include -L$(exec_prefix)/lib -lz
  5. 重新编译安装:make & make install

 

标签